/**
 * @module Mocha
 */
import { Suite, Test, Runner } from 'mocha';
import { TestUtils, TestCaseOpts } from './utils';
import { RpsContext } from 'rpscript-interface';
export default class RpsMocha {
    static util: TestUtils;
    constructor(ctx?: RpsContext);
    testSuite(ctx: RpsContext, opts: {}, suitename: string): Promise<Suite>;
    testCase(ctx: RpsContext, opts: TestCaseOpts, testname: string, fn: () => void): Promise<Test>;
    expect(ctx: RpsContext, opts: TestCaseOpts, expect: any, actual: any, ...chains: string[]): Promise<void>;
    testReport(ctx: RpsContext, opts: any): Promise<Runner>;
}
