"use strict";
/**
 * @module Mocha
 */
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("./utils");
const rpscript_interface_1 = require("rpscript-interface");
const context_1 = require("./context");
let RpsMocha = RpsMocha_1 = class RpsMocha {
    constructor(ctx) {
        if (ctx)
            ctx['mocha'] = new context_1.MochaContext;
    }
    testSuite(ctx, opts, suitename) {
        return __awaiter(this, void 0, void 0, function* () {
            return RpsMocha_1.util.createSuite(ctx['mocha'], {}, suitename);
        });
    }
    testCase(ctx, opts, testname, fn) {
        return __awaiter(this, void 0, void 0, function* () {
            return RpsMocha_1.util.createTestCase(ctx['mocha'], opts, testname, fn);
        });
    }
    expect(ctx, opts, expect, actual, ...chains) {
        return __awaiter(this, void 0, void 0, function* () {
            RpsMocha_1.util.parseChaiExpect(expect, actual, chains);
            return Promise.resolve();
        });
    }
    testReport(ctx, opts) {
        return __awaiter(this, void 0, void 0, function* () {
            return RpsMocha_1.util.runTest(ctx['mocha'], opts);
        });
    }
};
RpsMocha.util = new utils_1.TestUtils;
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'testSuite' })
], RpsMocha.prototype, "testSuite", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'testCase' })
], RpsMocha.prototype, "testCase", null);
__decorate([
    rpscript_interface_1.rpsActionSkipErrHandling({ verbName: 'expect' })
], RpsMocha.prototype, "expect", null);
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'testReport' })
], RpsMocha.prototype, "testReport", null);
RpsMocha = RpsMocha_1 = __decorate([
    rpscript_interface_1.RpsModule("mocha")
], RpsMocha);
exports.default = RpsMocha;
var RpsMocha_1;
