import { Suite, Test, Runner } from 'mocha';
import { MochaContext } from './context';
export interface TestCaseOpts {
    type?: string;
}
export interface ReportOptions {
    reporter: string;
    overwrite?: boolean;
    showPassed?: boolean;
    title?: string;
    reportFilename?: string;
    reportDir?: string;
    saveJson?: boolean;
    autoOpen?: boolean;
}
export declare class TestUtils {
    createSuite(ctx: MochaContext, opts: {}, suitename: string): Promise<Suite>;
    TC_DEFAULT: {
        type: string;
    };
    createTestCase(ctx: MochaContext, opts: TestCaseOpts, testname: string, fn: () => void): Promise<Test>;
    parseChaiExpect(expected: any, actual?: any, ...chains: any[]): any;
    DEFAULT_REPORTER: {
        reporter: string;
    };
    runTest(ctx: MochaContext, opts: any): Promise<Runner>;
}
